c HR1: Evolution of stars, main program
c miroslav.broz@usa.net, http://www.kolej.mff.cuni.cz/~broz/hr1/

      program hr1
c-----------------------------------------------------------------------

      include 'hr1.inc'
      include 'pg.inc'

c  XWindows returns 'A' and 'X' when pressing <left> and <right>
c  mouse button, Win95 returns NOTHING => one must press <Enter>
c  and <Esc> instead.
      character L,R
      parameter(L='A',R='X')
c      parameter(L=char(13),R=char(27))

c  dimensions of arrays
      integer ncommax,nboxmax,ndatmax,ndatmax_dat,ngra,nsp
      parameter(ncommax=10)
      parameter(nboxmax=25)
      parameter(ndatmax=10)
      parameter(ndatmax_dat=100)
      parameter(ngra=10)
      parameter(nsp=7)

c  radii to be computed
      real logR(nrecmax,nstamax)

c  chemical composition labels 
      real comp(nrecmax,ncommax)
      character*10 comptxt(ncommax)

c  things to be read from hr1.in file
      character*80 hr1datfile,device
      integer ndat
      character*80 datfile(ndatmax),dattxt(ndatmax)
      integer col_dat(ndatmax)
      real H_end, He_end, dHe_beg, He_max
      real sp(nsp+1)
      real hr_xmin,hr_xmax,hr_ymin,hr_ymax
      real menu_width,menu_aspect
      real hr_width,hr_aspect
      real gr_width,gr_aspect
      integer nstepmax
      integer menu_col1,menu_col2,menu_col3,menu_col4
      integer compcol(ncommax)
      integer gr_col(ngra)
      integer h_col,he_col,other_col
      integer sp_col(nsp)
      integer sta,gr,dat

c  variables read from *.dat files
      real logTe_dat(ndatmax_dat),logL_dat(ndatmax_dat)
      character*80 txt_dat(ndatmax_dat)

c  teporary variables
      integer i,j,pgopen,nc,id1,id2,idPS,idGIF,idgr,length,
     :  nmenu,pgband,ndat_dat
      real x0,y0,boxx(4,nboxmax),boxy(4,nboxmax),interp
      real dx1,dy1,dx2,dy2,minx,maxx,miny,maxy,dx,dy,xref,yref
      real sboxx(4,nstamax),sboxy(4,nstamax),col1,col2
      real time,dtime,tend,str2real
      character*80 grtxt(nboxmax),terminal,title
      character*10 masstxt(nstamax),ztxt(nstamax)
      character*5 dtimetxt,tendtxt
      logical inbox,rescale,batchmode,extra,show,idena,annohr,annosp,
     :  linie
      logical iden_dat(ndatmax_dat)
      character c
      real minlogMdot
      parameter(minlogMdot=-100.0)

c  special characters
      character BS
      character*2 UP,DOWN,TIMES
      parameter(BS='\\',UP=BS//'u',DOWN=BS//'d',TIMES=BS//'x')

c  menu identifiers
      integer nexit,nabout,nePS,neGIF,nzoom,ntrac,nevol,ndt,
     :  nfile,nshow,niden,nidena,ntend
      parameter(nexit=ngra+1)
      parameter(nabout=ngra+2)
      parameter(neGIF=ngra+3)
      parameter(nePS=ngra+4)
      parameter(nzoom=ngra+5)
      parameter(ntrac=ngra+6)
      parameter(nfile=ngra+7)
      parameter(nshow=ngra+8)
      parameter(niden=ngra+9)
      parameter(nidena=ngra+10)
      parameter(nevol=ngra+11)
      parameter(ndt=ngra+12)
      parameter(ntend=ngra+13)

c  chemical composition labels
      data comptxt/'X','Y','C12','C13','N14','O16','O17','O18',
     :  'Ne20','Ne22'/

c  menu labels data
      data grtxt/'HR diagram', 'luminosity', 'effective temperature',
     :  'radius', 'surface abundances', 'core mass fraction',
     :  'mass loss rate', 'central density', 'central temperature',
     :  'central abundances',
     :  'EXIT',
     :  'ABOUT',
     :  ', GIF',
     :  'EXPORT PS',
     :  'ZOOM',
     :  'TRACE',
     :  'FILE',
     :  '',
     :  'IDENTIFY',
     :  ', ALL',
     :  'EVOLVE',
     :  'dt=        Myr',
     :  'tE=        Myr',
     :  '',''/

c
c  read hr1.in parameter file (see the comments there)
c
      open(unit=1,name='./hr1.in',form='formatted',status='old',
     :  err=11)
c  read until the end of comments
20    continue
        read(1,10) hr1datfile
10      format(a)
      if (hr1datfile(1:1).eq.'#') goto 20
      read(1,10) device
      read(1,*) ndat
      do i=1,ndat
        read(1,30) datfile(i),col_dat(i),dattxt(i)
30      format(a14,i4,a)
      enddo
      read(1,*) H_end, He_end, dHe_beg
      read(1,*) (sp(i),i=1,nsp+1)
      read(1,*) hr_xmin,hr_xmax,hr_ymin,hr_ymax
      read(1,*) menu_width,menu_aspect
      read(1,*) hr_width,hr_aspect
      read(1,*) gr_width,gr_aspect
      read(1,*) nstepmax
      read(1,*) menu_col1,menu_col2,menu_col3,menu_col4
      read(1,*) (compcol(i),i=1,ncommax)
      read(1,*) (gr_col(i),i=1,ngra)
      read(1,*) h_col,he_col,other_col
      read(1,*) (sp_col(i),i=1,nsp)
      read(1,*) lw1,lw2,chs
      read(1,*) annohr,annosp,show,idena,linie,rescale
      read(1,*) time,dtime,tend
      read(1,*) sta,gr,dat
      close(1)

c  dtime editable box
      write(dtimetxt,'((f5.2))') dtime
      write(tendtxt,'((f5.1))') tend

      goto 21
11    write(*,*) 'HR1: Error reading parameter file hr1.in.'
      stop
21    continue

c
c  read hr1.dat binary file
c
      open(unit=2,name=hr1datfile,form='unformatted',status='old',
     :  err=13)
      read(2) nsta
      do i=1,nsta
        read(2) lrec(i),nrec(i),mass0(i),z(i)
        do j=1,nrec(i)
          read(2) Age(j,i),Mass(j,i),logL(j,i),logTe(j,i),
     :      X(j,i),Y(j,i),C12(j,i),C13(j,i),N14(j,i),O16(j,i),O17(j,i),
     :      O18(j,i),Ne20(j,i),Ne22(j,i),QCC(j,i),logTu(j,i),
     :      logMdot(j,i),logrhoc(j,i),logTc(j,i),Xc(j,i),Yc(j,i),
     :      C12c(j,i),C13c(j,i),N14c(j,i),O16c(j,i),O17c(j,i),O18c(j,i),
     :      Ne20c(j,i),Ne22c(j,i)
c  compute radii
          logR(j,i)=0.5*logL(j,i)-2.0*logTe(j,i)+2.0*log(5780.0)
c  Age in Myr
          Age(j,i)=Age(j,i)/1.0e6
c  correct mass loss rate
          if (abs(logMdot(j,i)).lt.1e-6) logMdot(j,i)=minlogMdot
        enddo
c  determine labels        
        call pgnumb(int(100*mass0(i)+0.5),-2,1,masstxt(i),nc)
        call pgnumb(int(10000*z(i)+0.5),-4,1,ztxt(i),nc)
      enddo
      close(2)

      goto 22
13    write(*,*) 'HR1: Error reading binary file hr1.dat.'
      stop
22    continue

c
c  open graphics device
c
      id1=pgopen(device)
      if (id1.le.0) then
        write(*,12) device(1:length(device))
12      format('HR1: Cannot open graphics device ',a,'.')
        stop
      endif
c  decide on batchmode
      call pgqinf('CURSOR',terminal,nc)
      if (terminal(1:nc).eq.'NO') then
        batchmode=.true.
      else
        batchmode=.false.
      endif
      if (batchmode) then
        write(*,*) 'HR1: Batchmode is on.'
        idgr=id1
        write(*,14) sta,gr,device(1:length(device))
14      format('HR1: Star ',i2,', graph ',i2,', device ',a,'.')
        rescale=.true.
        goto 120
      else
c
c  title page in id2 page
c
        id2=pgopen(device)
        call pgslct(id2)
        call pgpap(gr_width,gr_aspect)
        call pgqwin(minx,maxx,miny,maxy)
        call pgsci(yellow)
        call pgslw(lw1)
        call pgsch(2.5*chs)
        call pgqchs(dx1,dy1)
        call pgptxt((minx+maxx)/2,(miny+maxy)/2+1.0*dy1,0.0,0.5,
     :    'HR1: Evolution of stars')
        call pgsci(cyan)
        call pgsch(1.0*chs)
        call pgqchs(dx1,dy1)
        dy1=1.5*dy1
        call pgptxt((minx+maxx)/2,(miny+maxy)/2-1.0*dy1,0.0,0.5,
     :    '(c) 1998 by Miroslav Broz, version Dec 20'//UP//'th'//DOWN//
     :    ' 2006, freeware')
        call pgptxt((minx+maxx)/2,(miny+maxy)/2-2.0*dy1,0.0,0.5,
     :    'miroslav.broz@email.cz, '//
     :    'http://sirrah.troja.mff.cuni.cz/~mira/hr1/')

        idgr=id2	! default graphics device
        nmenu=max(nsta,ngra+11)

c  set up the 2nd window for menu
        call pgslct(id1)
        call pgask(.false.)
        call pgpap(menu_width,menu_aspect)
        call pgsvp(0.0,1.0,0.0,1.0)
        call pgswin(0.0,1.0,0.0,1.0)
        call pgslw(lw1)
        call pgsch(2.5*chs)
        call pgqchs(dx1,dy1)
        col1=3.0*dx1
        col2=6.5*dx1
        dy1=1.5*dy1
      endif
c
c  explanation of goto labels: 
c    100 => redraw menu
c    110 => don't redraw anything
c    120 => redraw graph and menu
c    999 => finish and close
c
c  create menu to choose mass and graph
c
100   continue
c  if program was called in batch mode, close device and stop
      if (batchmode) then
        call pgclos
        stop
      endif
c  if graph was exported, close device
      if (idgr.ne.id2) then
        call pgslct(idgr)
        call pgclos
        idgr=id2
      endif

      call pgslct(id1)
      call pgpage
      call pgbbuf
      
c  mass menu
      do i=1,nsta
        if (i.eq.sta) then
          call pgsci(menu_col4)
        else
          call pgsci(menu_col1)
        endif
        call pgptxt(col1,1.0-i*dy1,0.0,0.5,masstxt(i))
        call pgqtxt(col1,1.0-i*dy1,0.0,0.5,masstxt(i),
     :    sboxx(1,i),sboxy(1,i))
      enddo
c  graph menu
      do i=1,ngra
        if (i.eq.gr) then
          call pgsci(menu_col4)
        else
          call pgsci(menu_col2)
        endif
        call pgptxt(col2,1.0-i*dy1,0.0,0.0,
     :    grtxt(i))
        call pgqtxt(col2,1.0-i*dy1,0.0,0.0,
     :    grtxt(i),boxx(1,i),boxy(1,i))
      enddo
c  others menu
      call pgsci(menu_col3)
c  exit box
      call pgptxt(col2,1.0-nmenu*dy1,0.0,0.0,
     :  grtxt(nexit))
      call pgqtxt(col2,1.0-nmenu*dy1,0.0,0.0,
     :  grtxt(nexit),boxx(1,nexit),boxy(1,nexit))
c  about box
      call pgptxt(col2,1.0-(nmenu-1)*dy1,0.0,0.0,
     :  grtxt(nabout))
      call pgqtxt(col2,1.0-(nmenu-1)*dy1,0.0,0.0,
     :  grtxt(nabout),boxx(1,nabout),boxy(1,nabout))
c  export PS box
      call pgptxt(col2,1.0-(nmenu-2)*dy1,0.0,0.0,
     :  grtxt(nePS))
      call pgqtxt(col2,1.0-(nmenu-2)*dy1,0.0,0.0,
     :  grtxt(nePS),boxx(1,nePS),boxy(1,nePS))
c  export GIF box
      call pgptxt(boxx(3,nePS),1.0-(nmenu-2)*dy1,0.0,0.0,
     :  grtxt(neGIF))
      call pgqtxt(boxx(3,nePS),1.0-(nmenu-2)*dy1,0.0,0.0,
     :  grtxt(neGIF),boxx(1,neGIF),boxy(1,neGIF))
c  zoom box
      call pgptxt(col2,1.0-(nmenu-3)*dy1,0.0,0.0,
     :  grtxt(nzoom))
      call pgqtxt(col2,1.0-(nmenu-3)*dy1,0.0,0.0,
     :  grtxt(nzoom),boxx(1,nzoom),boxy(1,nzoom))
c  trace box
      call pgptxt(col2,1.0-(nmenu-4)*dy1,0.0,0.0,
     :  grtxt(ntrac))
      call pgqtxt(col2,1.0-(nmenu-4)*dy1,0.0,0.0,
     :  grtxt(ntrac),boxx(1,ntrac),boxy(1,ntrac))
c  evolve
      call pgptxt(col2,1.0-(nmenu-7)*dy1,0.0,0.0,
     :  grtxt(nevol))
      call pgqtxt(col2,1.0-(nmenu-7)*dy1,0.0,0.0,
     :  grtxt(nevol),boxx(1,nevol),boxy(1,nevol))
c  dt editable box
      call pgptxt(col2+1.5*dx1,1.0-(nmenu-5)*dy1,0.0,0.0,
     :  grtxt(ndt))
      call pgqtxt(col2+1.5*dx1,1.0-(nmenu-5)*dy1,0.0,0.0,
     :  grtxt(ndt),boxx(1,ndt),boxy(1,ndt))
      call pgptxt(col2+4.0*dx1,1.0-(nmenu-5)*dy1,0.0,0.0,
     :  dtimetxt(1:length(dtimetxt)))
c  tend editable box
      call pgptxt(col2+1.5*dx1,1.0-(nmenu-6)*dy1,0.0,0.0,
     :  't'//DOWN//'E'//UP//'=        Myr')
      call pgqtxt(col2+1.5*dx1,1.0-(nmenu-6)*dy1,0.0,0.0,
     :  grtxt(ntend),boxx(1,ntend),boxy(1,ntend))
      call pgptxt(col2+4.0*dx1,1.0-(nmenu-6)*dy1,0.0,0.0,
     :  tendtxt(1:length(tendtxt)))
c  identify box
      call pgptxt(col2,1.0-(nmenu-8)*dy1,0.0,0.0,
     :  grtxt(niden))
      call pgqtxt(col2,1.0-(nmenu-8)*dy1,0.0,0.0,
     :  grtxt(niden),boxx(1,niden),boxy(1,niden))
c  identify all box
      call pgptxt(boxx(3,niden),1.0-(nmenu-8)*dy1,0.0,0.0,
     :  grtxt(nidena))
      call pgqtxt(boxx(3,niden),1.0-(nmenu-8)*dy1,0.0,0.0,
     :  grtxt(nidena),boxx(1,nidena),boxy(1,nidena))
c  file box
      call pgptxt(col2,1.0-(nmenu-9)*dy1,0.0,0.0,
     :  grtxt(nfile))
      call pgqtxt(col2,1.0-(nmenu-9)*dy1,0.0,0.0,
     :  grtxt(nfile),boxx(1,nfile),boxy(1,nfile))
c  show box
      if (dat.gt.0) then
        call pgsci(col_dat(dat))
        call pgptxt(boxx(3,nfile)+1.0*dx1,1.0-(nmenu-9)*dy1,0.0,0.0,
     :    dattxt(dat))
        call pgsci(menu_col3)
      endif
      call pgqtxt(boxx(3,nfile)+1.0*dx1,1.0-(nmenu-9)*dy1,0.0,0.0,
     :  'XXXXXXXXXX',boxx(1,nshow),boxy(1,nshow))

      call pgebuf
c
c  wait for user input
c
110   call pgslct(id1)
      nc=pgband(0,0,x0,y0,x0,y0,c)

c  test about box button
      if ((c.eq.L).and.(inbox(x0,y0,boxx(1,nabout),boxy(1,nabout)))
     :  .or.(c.eq.'a')) then
        write(*,50)
50      format(' HR1: About box:',/
     :    'Evolution of stars interpolating grid of stellar models.',/
     :    '(c) Miroslav Broz 2006, version Dec 20th 2006, freeware ',/
     :    'miroslav.broz@email.cz, ',$,
     :    'http://sirrah.troja.mff.cuni.cz/~mira/hr1/',/)
        goto 110

c  test export PS button
      elseif ((c.eq.L).and.(inbox(x0,y0,boxx(1,nePS),boxy(1,nePS)))
     :  .or.(c.eq.'p')) then
        call pgslct(idgr)
        call pgqwin(minx,maxx,miny,maxy)
        idPS=pgopen('./hr1.ps/cps')
        if (idPS.le.0) then
          write(*,*) 'HR1: Cannot open graphics device hr1.ps/cps'
          goto 110
        else
          rescale=.false.
          idgr=idPS
          call pgslct(idgr)
          call pgpap(gr_width,gr_aspect)
          call pgswin(minx,maxx,miny,maxy)
          time=0.0
          write(*,*) 'HR1: Graph exported as hr1.ps.'
          goto 120
        endif

c  test export GIF button
      elseif ((c.eq.L).and.(inbox(x0,y0,boxx(1,neGIF),boxy(1,neGIF)))
     :  .or.(c.eq.'g')) then
        call pgslct(idgr)
        call pgqwin(minx,maxx,miny,maxy)
        idGIF=pgopen('./hr1.gif/gif')
        if (idGIF.le.0) then
          write(*,*) 'HR1: Cannot open graphics device hr1.gif/gif'
          goto 110
        else
          rescale=.false.
          idgr=idGIF
          call pgslct(idgr)
          call pgpap(gr_width,gr_aspect)
          call pgswin(minx,maxx,miny,maxy)
          time=0.0
          write(*,*) 'HR1: Graph exported as hr1.gif.'
          goto 120
        endif

c  test zoom button
      elseif ((c.eq.L).and.(inbox(x0,y0,boxx(1,nzoom),boxy(1,nzoom)))
     :  .or.(c.eq.'z')) then
        call pgslct(idgr)
        call pgsci(white)
c  differrent zoom method depending on type of graph 
        if (gr.eq.1) then
          nc=pgband(0,0,xref,yref,xref,yref,c)
c  if unzoom, don't ask further
          if (c.eq.R) then
            x0=xref
            y0=yref
          else
            nc=pgband(2,0,xref,yref,x0,y0,c)
          endif
        elseif (gr.eq.nevol) then
          nc=pgband(0,0,xref,yref,xref,yref,c)
          if (c.eq.R) then
            x0=xref
            y0=yref
          else
            nc=pgband(2,0,xref,yref,x0,y0,c)
          endif
          time=0.0
        else
          nc=pgband(6,0,x0,y0,x0,y0,c)
        endif
        call pgqwin(minx,maxx,miny,maxy)
        call pgpage
c  unzoom
        if (c.eq.R) then
          dx=0.75*(maxx-minx)
          dy=0.75*(maxy-miny)
c  special box zoom for chemical composition graphs
          if ((gr.eq.5).or.(gr.eq.10)) then
            call pgswin(
     :        max(x0-dx,Age(1,sta)),min(x0+dx,Age(nrec(sta),sta)),
     :        max(y0-dy,0.0),min(y0+dy,1.0))
          else
            call pgswin(x0-dx,x0+dx,y0-dy,y0+dy)
          endif
        else
c  zoom
          dx=0.1*(maxx-minx)
          dy=0.1*(maxy-miny)
          if ((gr.eq.1).or.(gr.eq.nevol)) then
            call pgswin(max(xref,x0),min(xref,x0),
     :        min(yref,y0),max(yref,y0))

c  special box zoom for chemical composition graphs
          elseif (((gr.eq.5).or.(gr.eq.10)).and.(c.eq.'z')) then
              call pgswin(max(x0-dx,minx),min(x0+dx,maxx),
     :          max(y0-dy,miny),min(y0+dy,maxy))
          else
            call pgswin(max(x0-dx,minx),min(x0+dx,maxx),miny,maxy)
          endif
        endif
        rescale=.false.
        goto 120
      elseif ((c.eq.R).and.(inbox(x0,y0,boxx(1,nzoom),boxy(1,nzoom)))
     : .or.(c.eq.'Z')) then
        rescale=.true.
        goto 120

c  test evolve button
      elseif ((c.eq.L).and.(inbox(x0,y0,boxx(1,nevol),boxy(1,nevol)))
     :  .or.(c.eq.'e')) then
        gr=nevol
        rescale=.true.
        time=0.0
        goto 120
      elseif ((c.eq.R).and.(inbox(x0,y0,boxx(1,nevol),boxy(1,nevol)))
     :  .or.(c.eq.'E')) then
        gr=nevol
        rescale=.false.
        goto 120

c  enter dtime
      elseif ((c.eq.L).and.(inbox(x0,y0,boxx(1,ndt),boxy(1,ndt)))
     :  .or.(c.eq.'d')) then
        nc=length(dtimetxt)
        call pgrstr(col2+4.0*dx1,1.0-(nmenu-5)*dy1,0.0,0.0,
     :    dtimetxt,nc,black)
        goto 100

c  enter dtend
      elseif ((c.eq.L).and.(inbox(x0,y0,boxx(1,ntend),boxy(1,ntend)))
     :  .or.(c.eq.'t')) then
        nc=length(tendtxt)
        call pgrstr(col2+4.0*dx1,1.0-(nmenu-6)*dy1,0.0,0.0,
     :    tendtxt,nc,black)
        goto 100

c  test file box, in/decrease dat
      elseif ((c.eq.L).and.(inbox(x0,y0,boxx(1,nfile),boxy(1,nfile)))
     :  .or.(c.eq.'f')) then
        dat=dat+1
        if (dat.gt.ndat) dat=1
        goto 100
      elseif ((c.eq.R).and.(inbox(x0,y0,boxx(1,nfile),boxy(1,nfile)))
     :  .or.(c.eq.'F')) then
        dat=dat-1
        if (dat.lt.1) dat=ndat
        goto 100

c  test show box
      elseif ((c.eq.L).and.(inbox(x0,y0,boxx(1,nshow),boxy(1,nshow)))
     :  .or.(c.eq.'s').or.) then
        if ((gr.eq.1).or.(gr.eq.nevol)) then
          call plot_datfile(datfile(dat))
          open(unit=1,name=datfile(dat),form='formatted',status='old',
     :      err=40)
          i=1
43        continue
            read(1,44,end=41) logTe_dat(i),logL_dat(i),txt_dat(i)
44          format(f6.4,f8.5,a)
            iden_dat(i)=.false.
            i=i+1
          goto 43
40        write(*,42) datfile(dat)(1:length(datfile(dat)))
42        format('HR1: Error opening file ',a) 
          goto 100
41        continue
          close(1)
          write(*,45) datfile(dat)(1:length(datfile(dat)))
45        format('HR1: Read file ',a) 

          ndat_dat=i-1
          show=.true.
          call pgslct(idgr)
          call pgsci(col_dat(dat))
          call pgshow(ndat_dat,logTe_dat,logL_dat)
        endif
        goto 100

      elseif ((c.eq.R).and.(inbox(x0,y0,boxx(1,nshow),boxy(1,nshow)))
     :  .or.(c.eq.'S')) then
        show=.false.
        goto 120

c  test identify all box
      elseif ((c.eq.L).and.(inbox(x0,y0,boxx(1,nidena),
     :  boxy(1,nidena))).or.(c.eq.'I')) then
        idena=.true.
        if ((gr.eq.1).or.(gr.eq.nevol)) then
          call pgslct(idgr)
          call pgidena(ndat_dat,logTe_dat,logL_dat)
        endif
        goto 100
      elseif ((c.eq.R).and.(inbox(x0,y0,boxx(1,nidena),
     :  boxy(1,nidena)))) then
        idena=.false.
        if ((gr.eq.1).or.(gr.eq.nevol)) then
          goto 120
        endif
        goto 100

c  test identify box
      elseif ((c.eq.L).and.(inbox(x0,y0,boxx(1,niden),boxy(1,niden)))
     :  .or.(c.eq.'i')) then
        if (((gr.eq.1).or.(gr.eq.nevol)).and.(ndat_dat.gt.0)) then
          call pgslct(idgr)
          call pgsave
          call pgsci(white)
          call pgsch(0.8*chs)
          call pgqchs(dx,dy)
70        continue
          nc=pgband(7,0,x0,y0,x0,y0,c)
          if ((c.eq.L).or.(c.eq.'l').or.(c.eq.'L')) then 
            do i=1,ndat_dat
              if ((x0.gt.logTe_dat(i)+dx).and.(x0.lt.logTe_dat(i)-dx)
     :          .and.(y0.gt.logL_dat(i)-dy).and.(y0.lt.logL_dat(i)+dy))
     :          then
                write(*,71) txt_dat(i)(1:length(txt_dat(i)))
71              format('HR1: Object identified: ',a)
                if (c.eq.'l') then
                  iden_dat(i)=.true.
                  nc=index(txt_dat(i),',')-1
                  if (nc.le.0) nc=length(txt_dat(i))
                  call pgptxt(logTe_dat(i)+1.0*dx,logL_dat(i)-0.5*dy,
     :              0.0,0.0,txt_dat(i)(1:nc))
                elseif (c.eq.'L') then
                  iden_dat(i)=.false.
                endif
              endif
            enddo
            goto 70
          endif
          call pgunsa
          goto 100
        else
          goto 100
        endif

c  test trace box
      elseif ((c.eq.L).and.(inbox(x0,y0,boxx(1,ntrac),boxy(1,ntrac)))
     :  .or.(c.eq.'t')) then
        write(*,*) 'HR1: Trace x,y:'
        call pgslct(idgr)
        call pgsci(white)
80      continue
        nc=pgband(7,0,x0,y0,x0,y0,c)
        if ((c.eq.L).or.(c.eq.'l')) then
          write(*,*) x0,y0
          goto 80
        else
          goto 100
        endif

c  test pressing 'l' on 'HR diagram' or 'EVOLVE' => linie of constant radius
      elseif ((c.eq.'l').and.(inbox(x0,y0,boxx(1,1),boxy(1,1))).or.
     :  (c.eq.'l').and.(inbox(x0,y0,boxx(1,nevol),boxy(1,nevol)))) then
        if (linie) then
          linie=.false.
        else
          linie=.true.
        endif
        goto 120

c  test exit button
      elseif ((c.eq.L).and.(inbox(x0,y0,boxx(1,nexit),boxy(1,nexit)))
     :  .or.(c.eq.R).or.(c.eq.'q')) then
        goto 999
      endif

c  test mass menu
      do i=1,nsta
        if ((c.eq.L).and.(inbox(x0,y0,sboxx(1,i),sboxy(1,i)))) then
          sta=i
          if (gr.eq.nevol) then
            rescale=.false.
          else
            call pgslct(idgr)
            call pgpage
          endif
          goto 120
        endif
      enddo
c  test graph menu
      do i=1,ngra
        if ((c.eq.L).and.(inbox(x0,y0,boxx(1,i),boxy(1,i)))) then
          gr=i
          rescale=.true.
          goto 120
        endif 
      enddo

      goto 110	! nothing to do?

c========================================================================

120   continue
      call pgslct(idgr)
      call pgask(.false.)
      call pgsci(white)
      call pgsch(1.0*chs)
      call pgslw(lw1)
c
c  HR digram
c
      if (gr.eq.1) then
        if (rescale) then
          call pgpap(hr_width,hr_aspect)
          call pgswin(hr_xmax,hr_xmin,hr_ymin,hr_ymax)
        endif
        if (linie) then
          call pglinie
        endif
        if (annohr) then
          call pgannohr(h_col,he_col,other_col)
        endif
        if (annosp) then
          call pgannosp(sp,sp_col)
        endif
        call pgqchs(dx2,dy2)
        call pgslw(lw2)
        do i=1,nrec(sta)-1
          call burning_col(Xc(i,sta),Yc(i,sta),H_end,He_end,dHe_beg,
     :      He_max,h_col,he_col,other_col)
          call pgline(2,logTe(i,sta),logL(i,sta))
        enddo
        call pgslw(lw1)
        call pgsci(white)
        call pgptxt(logTe(1,sta)-dx2,logL(1,sta)-dy2,0.0,1.0,
     :    masstxt(sta))
        call pgpt(nrec(sta),logTe(1,sta),logL(1,sta),20)
        call pgsci(white)
        if (Age(nrec(sta),sta).lt.1.0e2) then
          call pgnumb(int(Age(nrec(sta),sta)*10.0+0.5),-1,1,title,nc)
          title=title(1:nc)//' Myr'
          nc=nc+4
        else
          call pgnumb(int(Age(nrec(sta),sta)/10.0+0.5),-2,1,title,nc)
          title=title(1:nc)//' Gyr'
          nc=nc+4
        endif
        call pglab('log(T'//DOWN//'eff'//UP//'/K)',
     :    'log(L/L'//DOWN//'s'//UP//')',
     :    grtxt(gr)(1:length(grtxt(gr)))//
     :    ', M='//masstxt(sta)(1:length(masstxt(sta)))//
     :    ', Z='//ztxt(sta)(1:length(ztxt(sta)))//
     :    ', Age='//title)
        call pgbox('BCNST',0.0,0,'BCNST',0.0,0)
        if (show) then
          call pgsci(col_dat(dat))
          call pgshow(ndat_dat,logTe_dat,logL_dat)
          call pgiden(ndat_dat,logTe_dat,logL_dat,txt_dat,iden_dat)
          if (idena) then
            call pgidena(ndat_dat,logTe_dat,logL_dat)
          endif
        endif
c
c  optionally plot data files (with labels)
c

        goto 100
c
c  luminosity 
c
      elseif (gr.eq.2) then
        if (rescale) then
          call pgpap(gr_width,gr_aspect)
          call pgqmm(nrec(sta),Age(1,sta),logL(1,sta),
     :      minx,maxx,miny,maxy)
          dy=0.1*(maxy-miny)
          miny=miny-dy
          maxy=maxy+dy
          call pgswin(minx,maxx,miny,maxy)
        endif
        call pgbchta(nrec(sta),1,Age(1,sta),logL(1,sta),gr_col(gr))
        call pgsci(white)
        call pglab('Age [Myr]','log(L/L'//DOWN//'s'//UP//')',
     :    grtxt(gr)(1:length(grtxt(gr)))//
     :    ', M='//masstxt(sta)(1:length(masstxt(sta)))//
     :    ', Z='//ztxt(sta)(1:length(ztxt(sta))))
        call pgbox('BCNST',0.0,0,'BCNST',0.0,0)
c
c  effective teperature
c
      elseif (gr.eq.3) then
        if (rescale) then
          call pgpap(gr_width,gr_aspect)
          call pgqmm(nrec(sta),Age(1,sta),logTe(1,sta),
     :      minx,maxx,miny,maxy)
          dy=0.1*(maxy-miny)
          miny=miny-dy
          maxy=maxy+dy
          call pgswin(minx,maxx,miny,maxy)
        endif
        call pgbchta(nrec(sta),1,Age(1,sta),logTe(1,sta),gr_col(gr))
        call pgsci(white)
        call pglab('Age [Myr]','log(T'//DOWN//'eff'//UP//'/K)',
     :    grtxt(gr)(1:length(grtxt(gr)))//
     :    ', M='//masstxt(sta)(1:length(masstxt(sta)))//
     :    ', Z='//ztxt(sta)(1:length(ztxt(sta))))
        call pgbox('BCNST',0.0,0,'BNST',0.0,0)
        call pgbox('',0.0,0,'CLMST1',0.0,0)
c
c  radius
c
      elseif (gr.eq.4) then
        if (rescale) then
          call pgpap(gr_width,gr_aspect)
          call pgqmm(nrec(sta),Age(1,sta),logR(1,sta),
     :      minx,maxx,miny,maxy)
          dy=0.1*(maxy-miny)
          miny=miny-dy
          maxy=maxy+dy
          call pgswin(minx,maxx,miny,maxy)
        endif
        call pgbchta(nrec(sta),1,Age(1,sta),logR(1,sta),gr_col(gr))
        call pgsci(white)
        call pglab('Age [Myr]','log(R/R'//DOWN//'s'//UP//')',
     :    grtxt(gr)(1:length(grtxt(gr)))//
     :    ', M='//masstxt(sta)(1:length(masstxt(sta)))//
     :    ', Z='//ztxt(sta)(1:length(ztxt(sta))))
        call pgbox('BCNST',0.0,0,'BCNST',0.0,0)
c
c  surface chemical composition
c
      elseif (gr.eq.5) then
        if (rescale) then
          call pgpap(gr_width,gr_aspect)
          call pgswin(Age(1,sta),Age(nrec(sta),sta),0.0,1.0)
        endif
        do i=1,nrec(sta)
          comp(i,1)=X(i,sta)
          comp(i,2)=Y(i,sta)
          comp(i,3)=C12(i,sta)
          comp(i,4)=C13(i,sta)
          comp(i,5)=N14(i,sta)
          comp(i,6)=O16(i,sta)
          comp(i,7)=O17(i,sta)
          comp(i,8)=O18(i,sta)
          comp(i,9)=Ne20(i,sta)
          comp(i,10)=Ne22(i,sta)
        enddo
        call pgbchta(nrec(sta),ncommax,Age(1,sta),comp,compcol)
        call pgsci(white)
        call pglab('Age [Myr]','mass fraction',
     :    grtxt(gr)(1:length(grtxt(gr)))//
     :    ', M='//masstxt(sta)(1:length(masstxt(sta)))//
     :    ', Z='//ztxt(sta)(1:length(ztxt(sta))))
        call pgbox('BCNST',0.0,0,'BCNST',0.0,0)
        call pganno(ncommax,comptxt,compcol)
c
c  core mass fraction
c
      elseif (gr.eq.6) then
        if (rescale) then
          call pgpap(gr_width,gr_aspect)
          call pgswin(Age(1,sta),Age(nrec(sta),sta),0.0,1.0)
        endif
        call pgbchta(nrec(sta),1,Age(1,sta),QCC(1,sta),gr_col(gr))
        call pgsci(white)
        call pglab('Age [Myr]','mass fraction',
     :    grtxt(gr)(1:length(grtxt(gr)))//
     :    ', M='//masstxt(sta)(1:length(masstxt(sta)))//
     :    ', Z='//ztxt(sta)(1:length(ztxt(sta))))
        call pgbox('BCNST',0.0,0,'BCNST',0.0,0)
c
c  mass loss rate
c
      elseif (gr.eq.7) then
        if (rescale) then
          call pgpap(gr_width,gr_aspect)
c  eliminate zeros
          miny=-minlogMdot
          maxy=minlogMdot
          do i=1,nrec(sta)
            if (abs(logMdot(i,sta)-minlogMdot).gt.1e-6) then
              miny=min(logMdot(i,sta),miny) 
              maxy=max(logMdot(i,sta),maxy) 
            endif
          enddo
          if (abs(maxy-minlogMdot).le.1e-6) then
            maxy=0.0
            miny=-15.0
          endif
          dy=0.1*(maxy-miny)
          miny=miny-dy
          maxy=maxy+dy
          call pgswin(Age(1,sta),Age(nrec(sta),sta),miny,maxy)
        endif
        call pgbchta(nrec(sta),1,Age(1,sta),logMdot(1,sta),gr_col(gr))
        call pgsci(white)
        call pglab('Age [Myr]',
     :    'log(Mdot/M'//DOWN//'s'//UP//TIMES//'yr'//UP//'-1'//DOWN//')',
     :    grtxt(gr)(1:length(grtxt(gr)))//
     :    ', M='//masstxt(sta)(1:length(masstxt(sta)))//
     :    ', Z='//ztxt(sta)(1:length(ztxt(sta))))
        call pgbox('BCNST',0.0,0,'BCNST',0.0,0)
c
c  central density
c
      elseif (gr.eq.8) then
        if (rescale) then
          call pgpap(gr_width,gr_aspect)
          call pgqmm(nrec(sta),Age(1,sta),logrhoc(1,sta),
     :      minx,maxx,miny,maxy)
          dy=0.1*(maxy-miny)
          miny=miny-dy
          maxy=maxy+dy
          call pgswin(minx,maxx,miny,maxy)
        endif
        call pgbchta(nrec(sta),1,Age(1,sta),logrhoc(1,sta),gr_col(gr))
        call pgsci(white)
        call pglab('Age [Myr]',
     :    'log(rhoc/g'//TIMES//'cm'//UP//'-3'//DOWN//')',
     :    grtxt(gr)(1:length(grtxt(gr)))//
     :    ', M='//masstxt(sta)(1:length(masstxt(sta)))//
     :    ', Z='//ztxt(sta)(1:length(ztxt(sta))))
        call pgbox('BCNST',0.0,0,'BCNST',0.0,0)
c
c  central temperature
c
      elseif (gr.eq.9) then
        if (rescale) then
          call pgpap(gr_width,gr_aspect)
          call pgqmm(nrec(sta),Age(1,sta),logTc(1,sta),
     :      minx,maxx,miny,maxy)
          dy=0.1*(maxy-miny)
          miny=miny-dy
          maxy=maxy+dy
          call pgswin(minx,maxx,miny,maxy)
        endif
        call pgbchta(nrec(sta),1,Age(1,sta),logTc(1,sta),gr_col(gr))
        call pgsci(white)
        call pglab('Age [Myr]','log(T'//DOWN//'c'//UP//'/K)',
     :    grtxt(gr)(1:length(grtxt(gr)))//
     :    ', M='//masstxt(sta)(1:length(masstxt(sta)))//
     :    ', Z='//ztxt(sta)(1:length(ztxt(sta))))
        call pgbox('BCNST',0.0,0,'BCNST',0.0,0)
c
c  central chemical composition
c
      elseif (gr.eq.10) then
        if (rescale) then
          call pgpap(gr_width,gr_aspect)
          call pgswin(Age(1,sta),Age(nrec(sta),sta),0.0,1.0)
        endif
        do i=1,nrec(sta)
          comp(i,1)=Xc(i,sta)
          comp(i,2)=Yc(i,sta)
          comp(i,3)=C12c(i,sta)
          comp(i,4)=C13c(i,sta)
          comp(i,5)=N14c(i,sta)
          comp(i,6)=O16c(i,sta)
          comp(i,7)=O17c(i,sta)
          comp(i,8)=O18c(i,sta)
          comp(i,9)=Ne20c(i,sta)
          comp(i,10)=Ne22c(i,sta)
        enddo
        call pgbchta(nrec(sta),ncommax,Age(1,sta),comp,compcol)
        call pgsci(white)
        call pglab('Age [Myr]','mass fraction',
     :    grtxt(gr)(1:length(grtxt(gr)))//
     :    ', M='//masstxt(sta)(1:length(masstxt(sta)))//
     :    ', Z='//ztxt(sta)(1:length(ztxt(sta))))
        call pgbox('BCNST',0.0,0,'BCNST',0.0,0)
        call pganno(ncommax,comptxt,compcol)
c
c  evolve
c
      elseif (gr.eq.nevol) then
        if (rescale) then
          call pgpap(hr_width,hr_aspect)
          call pgswin(hr_xmax,hr_xmin,hr_ymin,hr_ymax)
        endif
        call pgqwin(minx,maxx,miny,maxy)
        call pgqchs(dx2,dy2)
        if (annohr) then
          call pgannohr(h_col,he_col,other_col)
        endif
        if (show) then
          call pgsci(col_dat(dat))
          call pgshow(ndat_dat,logTe_dat,logL_dat)
          call pgiden(ndat_dat,logTe_dat,logL_dat,txt_dat,iden_dat)
          if (idena) then
            call pgidena(ndat_dat,logTe_dat,logL_dat)
          endif
        endif
        call pgsci(white)
        call pglab('log(T'//DOWN//'eff'//UP//'/K)',
     :    'log(L/L'//DOWN//'s'//UP//')',
     :    'Evolution in HR diagram')
        call pgbox('BCNST',0.0,0,'BCNST',0.0,0)
        title=''
        nc=1

c  adjust tend
        tend=str2real(tendtxt)
        if (tend.lt.0) then
          tend=Age(nrec(sta),sta)
        endif
c  adjust dtime
        dtime=str2real(dtimetxt)
        if (nstepmax*dtime.lt.tend) then
          dtime=tend/nstepmax
          write(*,60) dtime
60        format('HR1: dt too small, increased upto dt=',f7.2,' Myr')
        endif
c  mass labels
        do i=1,nsta
          if (i.eq.sta) then
            call pgsci(white)
          else
            call pgsci(gray)
          endif
          call pgptxtc(logTe(1,i)-dx2,logL(1,i)-dy2,0.0,1.0,
     :      masstxt(i))
        enddo

200     continue
        if (time.gt.tend) goto 210
          do i=1,nsta
            dx=interp(nrec(i),Age(1,i),logTe(1,i),time,extra)
            if (.not.(extra)) then
              dy=interp(nrec(i),Age(1,i),logL(1,i),time,extra)
              if (i.eq.sta) then
c  decide on burning phase
                call burning_col(
     :            interp(nrec(i),Age(1,i),Xc(1,i),time,extra),
     :            interp(nrec(i),Age(1,i),Yc(1,i),time,extra),
     :            H_end,He_end,dHe_beg,He_max,
     :            h_col,he_col,other_col)
                call pgpt1(dx,dy,-7)
              else
                call pgsci(gray)
                call pgpt1(dx,dy,20)
              endif
            endif 
          enddo
          call pgsci(black)
          call pgptxt(maxx,maxy+2.0*dy2,0.0,1.0,
     :      't = '//title(1:nc)//' Myr')
          call pgsci(white)
          call pgnumb(int(time*1.0e2+0.5),-2,1,title,nc)
          call pgptxt(maxx,maxy+2.0*dy2,0.0,1.0,
     :      't = '//title(1:nc)//' Myr')
          time=time+dtime
        goto 200
210     continue

      endif
c  end of graph selection
      goto 100

999   continue
      call pgclos

      end

c=======================================================================




      subroutine pgptxtc(x,y,angle,fjust,text)
c  draw text with clipping
      real x,y,angle,fjust
      character*(*) text
c-----------------------------------------------------------------------
      real minx,maxx,miny,maxy,dx,dy

      call pgqwin(minx,maxx,miny,maxy)
      call pgqchs(dx,dy)
      if ((x.gt.min(minx,maxx)).and.(x.lt.max(minx,maxx)).and.
     :  (y.gt.min(miny,maxy-dy)).and.(y.lt.max(miny,maxy-dy))) then
        call pgptxt(x,y,angle,fjust,text)
      endif
      return
      end

      subroutine pgiden1(x,y,txt,dx,dy)
c  place label txt at point (x,y), must provide actual dx,dy
      implicit none
      real x,y,dx,dy
      character txt*(*)
c-----------------------------------------------------------------------
      integer nc,length
      nc=index(txt,',')-1
      if (nc.le.0) nc=length(txt)
      call pgptxt(x+1.0*dx,y-0.5*dy,0.0,0.0,txt(1:nc))
      return
      end

      subroutine pgiden(n,x,y,txt,iden)
c  place label txt(i) at point (x(i),y(i)) if iden(i) is .true.
      implicit none
      include 'pg.inc'
      integer n
      real x(n),y(n)
      character*80 txt(n)
      logical iden(n)
c-----------------------------------------------------------------------
      integer i
      real dx,dy,minx,maxx,miny,maxy
      call pgsave
      call pgqchs(dx,dy)
      call pgqwin(minx,maxx,miny,maxy)
      call pgsci(white)
      call pgsch(0.8*chs)
      do i=1,n
        if (iden(i)) then
c  clipping of the text
          if ((x(i).lt.minx).and.(x(i).gt.maxx).and.
     :      (y(i).gt.miny).and.(y(i).lt.maxy)) then
            call pgiden1(x(i),y(i),txt(i),dx,dy)
          endif
        endif
      enddo
      call pgunsa
      return
      end

      subroutine pgidena(n,x,y)
c  identify all points (x,y) by its number
      implicit none
      include 'pg.inc'
      integer n
      real x(n),y(n)
c-----------------------------------------------------------------------
      integer i,nc
      real dx,dy,minx,maxx,miny,maxy
      character*80 title
      call pgsave
      call pgsci(white)
      call pgsch(0.8*chs)
      call pgqchs(dx,dy)
      call pgqwin(minx,maxx,miny,maxy)
      do i=1,n
        if ((x(i).lt.minx).and.(x(i).gt.maxx).and.
     :    (y(i).gt.miny).and.(y(i).lt.maxy)) then
          call pgnumb(i,0,1,title,nc)
          call pgptxt(x(i)+1.0*dx,y(i)-0.5*dy,0.0,0.0,title(1:nc))
        endif
      enddo
      call pgunsa
      return
      end

      subroutine pgshow(n,x,y)
c  show objects in dat file
      implicit none
      integer n
      real x(n),y(n)
c-----------------------------------------------------------------------
      integer i
      do i=1,n
        call pgpt1(x(i),y(i),-7) 
      enddo
      return
      end

      subroutine pgbchta(nx,ny,x,yz,colors)
c  draw bar chart
      implicit none
      integer nxmax,nymax
      parameter(nxmax=51)
      parameter(nymax=10)
      integer nx,ny,colors(nymax)
      real x(nxmax),yz(nxmax,nymax) 
c-----------------------------------------------------------------------
      integer i,j
      real px(2*nxmax),py(2*nxmax)
      real minx,maxx,miny,maxy

      call pgbbuf
      call pgqwin(minx,maxx,miny,maxy)
      do i=1,nx
        px(i)=x(i)
        px(2*nx+1-i)=x(i)
        py(i)=miny
        py(2*nx+1-i)=yz(i,1)
      enddo
      call pgsci(colors(1))
      call pgsfs(1)
      call pgpoly(2*nx,px,py)

      do i=2,ny
        do j=1,nx
          py(j)=py(2*nx+1-j)
          py(2*nx+1-j)=py(2*nx+1-j)+yz(j,i)
        enddo
        call pgsci(colors(i))
        call pgpoly(2*nx,px,py)
c        call pgsci(1)
c        call pgline(nx,px,py)
      enddo
      call pgebuf

      return
      end

      logical function inbox(x,y,boxx,boxy)
c  test if inside box
      real x,y,boxx(4),boxy(4)
c-----------------------------------------------------------------------
      if ((x.ge.boxx(1)).and.(x.le.boxx(3)).and.
     :  (y.ge.boxy(1)).and.(y.le.boxy(2))) then
        inbox=.true.
      else
        inbox=.false.
      endif
      return
      end

      integer function length(s)
c  length of string without spaces
      character s*(*)
c-----------------------------------------------------------------------
      integer l
      do l=len(s),1,-1
        if (s(l:l).ne.' ') goto 10
      enddo
10    length=l
      return
      end

      subroutine pgqmm(n,x,y,minx,maxx,miny,maxy)
c  query x,y arrays minima and maxima
      integer n
      real x(n),y(n),minx,maxx,miny,maxy
c-----------------------------------------------------------------------
      minx=x(1)
      maxx=x(1)
      miny=y(1)
      maxy=y(1)
      do i=2,n
        minx=min(x(i),minx)
        maxx=max(x(i),maxx)
        miny=min(y(i),miny)
        maxy=max(y(i),maxy)
      enddo
      return
      end

      subroutine pgqchs(dx,dy)
c  query actual 'H' character size in world coordinates
      real dx,dy
c-----------------------------------------------------------------------
      real boxx(4),boxy(4)
      call pgqtxt(0.0,0.0,0.0,0.0,'H',boxx,boxy)
      dy=boxy(2)-boxy(1)
      dx=boxx(3)-boxx(1)
      return
      end

      subroutine pganno(n,txts,colors)
c  annotate composition graphs
      integer n,colors(n)
      character*10 txts(n)
c-----------------------------------------------------------------------
      include 'pg.inc'
      real minx,maxx,miny,maxy,dx,dy,dy2

      call pgqchs(dx,dy)
      call pgqwin(minx,maxx,miny,maxy)
      call pgsclp(0)
      dy2=1.75*dy	! englare bars
      do i=1,n
        call pgsci(colors(i))
        call pgsfs(1)
        call pgrect(maxx+3.0*dx-2.0*dx,maxx+3.0*dx+2.0*dx,
     :    maxy-dy2*i,maxy-dy2*(i-1))
        call pgsci(black)
        call pgptxt(maxx+3.0*dx,maxy-dy2*(i-0.5)-0.5*dy,0.0,0.5,txts(i))
      enddo
      call pgsci(white)
      call pgsfs(2)
      call pgrect(maxx+3.0*dx-2.0*dx,maxx+3.0*dx+2.0*dx,
     :  maxy,maxy-dy2*n)
      call pgsclp(1)
      return
      end

      subroutine pgannosp(sp,sp_col)
c  annotate spectral types
      integer nsp
      parameter(nsp=7)
      integer sp_col(nsp)
      real sp(nsp+1)
c-----------------------------------------------------------------------
      include 'pg.inc'
      real minx,maxx,miny,maxy,dx,dy
      character sp_txt(nsp)
      data sp_txt/'M','K','G','F','A','B','O'/

      call pgsave
      call pgqchs(dx,dy)
      call pgqwin(minx,maxx,miny,maxy)
      do i=1,nsp
        call pgsci(sp_col(i))
        call pgsfs(1)
        call pgrect(sp(i),sp(i+1),miny,miny+1.5*dy)
        call pgsci(black)
        call pgptxt((sp(i)+sp(i+1))/2,miny+0.5/2*1.5*dy,
     :    0.0,0.5,sp_txt(i))
      enddo
      call pgunsa
      return
      end

      subroutine pglinie
c  linie of constant density in HRD
c-----------------------------------------------------------------------
      include 'pg.inc'
      integer i
      real minx,maxx,miny,maxy,dx,dy
      real logTe_sun
      parameter(logTe_sun=3.76193)
      character*80 str
      integer length

      call pgsave
      call pgqwin(minx,maxx,miny,maxy)
      call pgsci(gray)
      call pgsls(2)
      call pgsch(1.0*chs)
      call pgqchs(dx,dy)
      do i=-4,4
        call pgmove(minx,2.0*i+4*(minx-logTe_sun)) 
        call pgdraw(maxx,2.0*i+4*(maxx-logTe_sun)) 
        if (i.ge.2) then
          write(str,'((a,i1,a))') '10\\u',i,'\\d'
        elseif (i.le.-3) then
          write(str,'((a,i2,a))') '10\\u',i,'\\d'
        elseif (i.ge.0) then
          write(str,'((i5))') int(10**i+0.5)
        else
          write(str,'((f6.4))') 10.**i
        endif
        call trim0(str)
c        str=str(1:length(str))//' R\\dS\\u'
        if (2.0*i+4*(minx-logTe_sun).lt.maxy) then
          call pgptxt(minx+0.5*dx,2.0*i+4*(minx-logTe_sun),0.0,0.0,
     :      str(1:length(str)))
        else
          call pgptxt((maxy-2.0*i)/4.0+logTe_sun-0.5*dx,maxy-1.5*dy,
     :      0.0,0.5,str(1:length(str)))
        endif
      enddo
      call pgunsa
      return
      end

      subroutine trim0(s)
c trim trailing zero's
      character*(*) s
c-----------------------------------------------------------------------
      integer i

      i=1
5     continue
      if ((i.eq.len(s)).or.(s(i:i).ne.' ')) goto 15
        i=i+1
      goto 5
15    continue
      s=s(i:)

      if (index(s,'.').eq.0) return
      i=len(s)
10    continue
      if ((i.eq.0).or.(.not.((s(i:i).eq.' ').or.(s(i:i).eq.'0'))))
     :  goto 20
        i=i-1
      goto 10
20    continue
      s=s(1:i)
      return
      end

      subroutine pgannohr(h_col,he_col,other_col)
c  annotate hr diagram
      integer h_col,he_col,other_col
c-----------------------------------------------------------------------
      include 'pg.inc'
      real minx,maxx,miny,maxy,dx,dy,dy2

      call pgsave
      call pgqchs(dx,dy)
      call pgqwin(minx,maxx,miny,maxy)
      call pgsclp(0)
      dy2=1.25*dy	! englare bars
      call pgsci(h_col)
      call pgpt1(minx+2.5*dx,miny+5.0*dy2+dy/3,-7)
      call pgsci(he_col)
      call pgpt1(minx+2.5*dx,miny+4.0*dy2+dy/3,-7)
      call pgsci(other_col)
      call pgpt1(minx+2.5*dx,miny+3.0*dy2+dy/3,-7)
      call pgsci(white)
      call pgptxt(minx+4.0*dx,miny+5.0*dy2,0.0,0.0,'core H burning')
      call pgptxt(minx+4.0*dx,miny+4.0*dy2,0.0,0.0,'core He burning')
      call pgptxt(minx+4.0*dx,miny+3.0*dy2,0.0,0.0,'other phases')
      call pgsclp(1)
      call pgunsa
      return
      end

      subroutine burning_col(Xc,Yc,H_end,He_end,dHe_beg,He_max,
     :  h_col,he_col,other_col)
c  decide on burning phase and set color
        real Xc,Yc,H_end,He_end,dHe_beg,He_max
        integer h_col,he_col,other_col
c-----------------------------------------------------------------------
        if (Xc.gt.H_end+1.0e-8) then
          He_max=Yc
          call pgsci(h_col)
        elseif ((Yc.gt.He_end+1.0e-8).and.(Yc.lt.He_max-dHe_beg)) then 
          call pgsci(he_col)
        else
          call pgsci(other_col)
        endif
      return
      end

      real function interp(n,x,y,x0,extra)
c  linear interpolation
      integer n
      real x(n),y(n),x0
      logical extra
c-----------------------------------------------------------------------

      integer i
      i=0
10    continue
        i=i+1
      if ((x0.gt.x(i)).and.(i.le.n)) goto 10

      if (i.eq.1) then
        extra=.true.
        i=2
      elseif (i.gt.n) then
        extra=.true.
        i=n
      else
        extra=.false.
      endif
      
      interp=((y(i)-y(i-1))*x0+y(i-1)*x(i)-y(i)*x(i-1))/(x(i)-x(i-1))

      return
      end

      SUBROUTINE PGRSTR(X, Y, ANGLE, FJUST, TEXT, LSTR, BCI)
      REAL X, Y, ANGLE, FJUST
      CHARACTER*(*) TEXT
      INTEGER LSTR, BCI
C-----------------------------------------------------------------------
      CHARACTER CH
      INTEGER JUNK, PGBAND, CI
      REAL XCUR, YCUR, XBOX(4), YBOX(4)
C
      CALL PGQCI(CI)
C
 10   CONTINUE
C     -- Draw current string
          IF (LSTR.GT.0) THEN
             CALL PGPTXT(X, Y, ANGLE, FJUST, TEXT(1:LSTR))
             CALL PGQTXT(X, Y, ANGLE, FJUST, TEXT(1:LSTR), XBOX, YBOX)
             XCUR = XBOX(4)
             YCUR = YBOX(4)
          ELSE
             XCUR = X
             YCUR = Y
          END IF
C         -- Read a character
          JUNK = PGBAND(0, 1, XCUR, YCUR, XCUR, YCUR, CH)
C         -- Erase old string
          CALL PGSCI(BCI)
          IF (LSTR.GT.0)
     :         CALL PGPTXT(X, Y, ANGLE, FJUST, TEXT(1:LSTR))
          CALL PGSCI(CI)
C         -- Avoid problem with PGPLOT escape character
          IF (CH.EQ.CHAR(92)) CH = '*'
C         -- Backspace (ctrl H) or delete removes last character
          IF (ICHAR(CH).EQ.8 .OR. ICHAR(CH).EQ.127) THEN
             IF (LSTR.GT.0) TEXT(LSTR:LSTR) = ' '
             IF (LSTR.GT.0) LSTR = LSTR-1
C         -- Ctrl U removes entire string
          ELSE IF (ICHAR(CH).EQ.21) THEN
             TEXT(1:LSTR) = ' '
             LSTR = 0
C         -- Any other non-printing character terminates input
          ELSE IF (ICHAR(CH).LT.32) THEN
             IF (LSTR.GT.0)
     :            CALL PGPTXT(X, Y, ANGLE, FJUST, TEXT(1:LSTR))
             GOTO 20
C         -- Otherwise, add character to string if there is room
          ELSE IF (LSTR.LT.LEN(TEXT)) THEN
             LSTR = LSTR+1
             TEXT(LSTR:LSTR) = CH
          END IF
      GOTO 10
C
 20   RETURN
      END

      real function str2real (txt)
c  try to convert string to real number, assuming decimal notation,
c  if fails returns zero
      character*(*) txt
c-----------------------------------------------------------------------
      character digits(0:9)
      character*10 text
      integer i,j,k,sign
      data digits/'0','1','2','3','4','5','6','7','8','9'/

      str2real=0.0
c  drop leading spaces...
      k=1
5     continue
        if (txt(k:k).ne.' ') goto 15
        k=k+1
      goto 5
15    continue
      text=txt(k:)

c  get sign
      k=index(text,'-')
      if (k.gt.0) then
        sign=-1
        text=text(k+1:)
      else
        sign=+1
        text=text
      endif

c  integer and decimal part
      k=index(text,'.')
      if (k.eq.0) then
        k=length(text)
        do i=1,k
          do j=0,9
            if (text(i:i).eq.digits(j)) goto 10
          enddo
10        str2real=str2real+j*10.0**(k-i)
        enddo
      else
        do i=1,k-1
          do j=0,9
            if (text(i:i).eq.digits(j)) goto 20
          enddo
20        str2real=str2real+j*10.0**(k-1-i)
        enddo 
        do i=k+1,length(text)
          do j=0,9
            if (text(i:i).eq.digits(j)) goto 30
          enddo
30        str2real=str2real+j*10.0**(-i+k)
        enddo 
      endif
      
      str2real=str2real*sign 
      return
      end

